from telethon.tl.mtproto_request import MTProtoRequest


class RegisterDeviceRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    account.registerDevice#637ea878 token_type:int token:string = Bool"""

    def __init__(self, token_type, token):
        """
        :param token_type: Telegram type: «int».
        :param token: Telegram type: «string».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0x637ea878

        self.token_type = token_type
        self.token = token

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.write_int(self.token_type)
        writer.tgwrite_string(self.token)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'account.registerDevice#637ea878 token_type:int token:string = Bool'

    def __str__(self):
        return '(account.registerDevice (ID: 0x637ea878) = (token_type={}, token={}))'.format(str(self.token_type), str(self.token))
