from telethon.tl.mtproto_request import MTProtoRequest


class ResetAuthorizationRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    account.resetAuthorization#df77f3bc hash:long = Bool"""

    def __init__(self, hash):
        """
        :param hash: Telegram type: «long».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0xdf77f3bc

        self.hash = hash

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.write_long(self.hash)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'account.resetAuthorization#df77f3bc hash:long = Bool'

    def __str__(self):
        return '(account.resetAuthorization (ID: 0xdf77f3bc) = (hash={}))'.format(str(self.hash))
