from telethon.tl.mtproto_request import MTProtoRequest


class UpdateNotifySettingsRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    account.updateNotifySettings#84be5b93 peer:InputNotifyPeer settings:InputPeerNotifySettings = Bool"""

    def __init__(self, peer, settings):
        """
        :param peer: Telegram type: «InputNotifyPeer».
        :param settings: Telegram type: «InputPeerNotifySettings».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0x84be5b93

        self.peer = peer
        self.settings = settings

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        self.peer.on_send(writer)
        self.settings.on_send(writer)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'account.updateNotifySettings#84be5b93 peer:InputNotifyPeer settings:InputPeerNotifySettings = Bool'

    def __str__(self):
        return '(account.updateNotifySettings (ID: 0x84be5b93) = (peer={}, settings={}))'.format(str(self.peer), str(self.settings))
