from telethon.tl.mtproto_request import MTProtoRequest


class ImportAuthorizationRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    auth.importAuthorization#e3ef9613 id:int bytes:bytes = auth.Authorization"""

    def __init__(self, id, bytes):
        """
        :param id: Telegram type: «int».
        :param bytes: Telegram type: «bytes».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0xe3ef9613

        self.id = id
        self.bytes = bytes

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.write_int(self.id)
        writer.tgwrite_bytes(self.bytes)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'auth.importAuthorization#e3ef9613 id:int bytes:bytes = auth.Authorization'

    def __str__(self):
        return '(auth.importAuthorization (ID: 0xe3ef9613) = (id={}, bytes={}))'.format(str(self.id), str(self.bytes))
