from telethon.tl.mtproto_request import MTProtoRequest


class SignInRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    auth.signIn#bcd51581 phone_number:string phone_code_hash:string phone_code:string = auth.Authorization"""

    def __init__(self, phone_number, phone_code_hash, phone_code):
        """
        :param phone_number: Telegram type: «string».
        :param phone_code_hash: Telegram type: «string».
        :param phone_code: Telegram type: «string».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0xbcd51581

        self.phone_number = phone_number
        self.phone_code_hash = phone_code_hash
        self.phone_code = phone_code

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.tgwrite_string(self.phone_number)
        writer.tgwrite_string(self.phone_code_hash)
        writer.tgwrite_string(self.phone_code)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'auth.signIn#bcd51581 phone_number:string phone_code_hash:string phone_code:string = auth.Authorization'

    def __str__(self):
        return '(auth.signIn (ID: 0xbcd51581) = (phone_number={}, phone_code_hash={}, phone_code={}))'.format(str(self.phone_number), str(self.phone_code_hash), str(self.phone_code))
