from telethon.tl.mtproto_request import MTProtoRequest


class DeleteUserHistoryRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    channels.deleteUserHistory#d10dd71b channel:InputChannel user_id:InputUser = messages.AffectedHistory"""

    def __init__(self, channel, user_id):
        """
        :param channel: Telegram type: «InputChannel».
        :param user_id: Telegram type: «InputUser».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0xd10dd71b

        self.channel = channel
        self.user_id = user_id

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        self.channel.on_send(writer)
        self.user_id.on_send(writer)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'channels.deleteUserHistory#d10dd71b channel:InputChannel user_id:InputUser = messages.AffectedHistory'

    def __str__(self):
        return '(channels.deleteUserHistory (ID: 0xd10dd71b) = (channel={}, user_id={}))'.format(str(self.channel), str(self.user_id))
