from telethon.tl.mtproto_request import MTProtoRequest


class ExportMessageLinkRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    channels.exportMessageLink#c846d22d channel:InputChannel id:int = ExportedMessageLink"""

    def __init__(self, channel, id):
        """
        :param channel: Telegram type: «InputChannel».
        :param id: Telegram type: «int».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0xc846d22d

        self.channel = channel
        self.id = id

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        self.channel.on_send(writer)
        writer.write_int(self.id)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'channels.exportMessageLink#c846d22d channel:InputChannel id:int = ExportedMessageLink'

    def __str__(self):
        return '(channels.exportMessageLink (ID: 0xc846d22d) = (channel={}, id={}))'.format(str(self.channel), str(self.id))
