from telethon.tl.mtproto_request import MTProtoRequest


class ToggleSignaturesRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    channels.toggleSignatures#1f69b606 channel:InputChannel enabled:Bool = Updates"""

    def __init__(self, channel, enabled):
        """
        :param channel: Telegram type: «InputChannel».
        :param enabled: Telegram type: «Bool».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0x1f69b606

        self.channel = channel
        self.enabled = enabled

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        self.channel.on_send(writer)
        writer.tgwrite_bool(self.enabled)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'channels.toggleSignatures#1f69b606 channel:InputChannel enabled:Bool = Updates'

    def __str__(self):
        return '(channels.toggleSignatures (ID: 0x1f69b606) = (channel={}, enabled={}))'.format(str(self.channel), str(self.enabled))
