from telethon.tl.mtproto_request import MTProtoRequest


class ResetTopPeerRatingRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    contacts.resetTopPeerRating#1ae373ac category:TopPeerCategory peer:InputPeer = Bool"""

    def __init__(self, category, peer):
        """
        :param category: Telegram type: «TopPeerCategory».
        :param peer: Telegram type: «InputPeer».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0x1ae373ac

        self.category = category
        self.peer = peer

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        self.category.on_send(writer)
        self.peer.on_send(writer)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'contacts.resetTopPeerRating#1ae373ac category:TopPeerCategory peer:InputPeer = Bool'

    def __str__(self):
        return '(contacts.resetTopPeerRating (ID: 0x1ae373ac) = (category={}, peer={}))'.format(str(self.category), str(self.peer))
