from telethon.tl.mtproto_request import MTProtoRequest


class CreateChatRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.createChat#09cb126e users:Vector<InputUser> title:string = Updates"""

    def __init__(self, users, title):
        """
        :param users: Telegram type: «InputUser». Must be a list.
        :param title: Telegram type: «string».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0x9cb126e

        self.users = users
        self.title = title

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.users))
        for users_item in self.users:
            users_item.on_send(writer)

        writer.tgwrite_string(self.title)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.createChat#09cb126e users:Vector<InputUser> title:string = Updates'

    def __str__(self):
        return '(messages.createChat (ID: 0x9cb126e) = (users={}, title={}))'.format(None if not self.users else [str(_) for _ in self.users], str(self.title))
