from telethon.tl.mtproto_request import MTProtoRequest


class DeleteChatUserRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.deleteChatUser#e0611f16 chat_id:int user_id:InputUser = Updates"""

    def __init__(self, chat_id, user_id):
        """
        :param chat_id: Telegram type: «int».
        :param user_id: Telegram type: «InputUser».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0xe0611f16

        self.chat_id = chat_id
        self.user_id = user_id

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.write_int(self.chat_id)
        self.user_id.on_send(writer)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.deleteChatUser#e0611f16 chat_id:int user_id:InputUser = Updates'

    def __str__(self):
        return '(messages.deleteChatUser (ID: 0xe0611f16) = (chat_id={}, user_id={}))'.format(str(self.chat_id), str(self.user_id))
