from telethon.tl.mtproto_request import MTProtoRequest


class EditChatTitleRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.editChatTitle#dc452855 chat_id:int title:string = Updates"""

    def __init__(self, chat_id, title):
        """
        :param chat_id: Telegram type: «int».
        :param title: Telegram type: «string».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0xdc452855

        self.chat_id = chat_id
        self.title = title

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.write_int(self.chat_id)
        writer.tgwrite_string(self.title)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.editChatTitle#dc452855 chat_id:int title:string = Updates'

    def __str__(self):
        return '(messages.editChatTitle (ID: 0xdc452855) = (chat_id={}, title={}))'.format(str(self.chat_id), str(self.title))
