from telethon.tl.mtproto_request import MTProtoRequest


class GetDialogsRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    messages.getDialogs#6b47f94d offset_date:date offset_id:int offset_peer:InputPeer limit:int = messages.Dialogs"""

    def __init__(self, offset_date, offset_id, offset_peer, limit):
        """
        :param offset_date: Telegram type: «date».
        :param offset_id: Telegram type: «int».
        :param offset_peer: Telegram type: «InputPeer».
        :param limit: Telegram type: «int».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0x6b47f94d

        self.offset_date = offset_date
        self.offset_id = offset_id
        self.offset_peer = offset_peer
        self.limit = limit

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.tgwrite_date(self.offset_date)
        writer.write_int(self.offset_id)
        self.offset_peer.on_send(writer)
        writer.write_int(self.limit)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.getDialogs#6b47f94d offset_date:date offset_id:int offset_peer:InputPeer limit:int = messages.Dialogs'

    def __str__(self):
        return '(messages.getDialogs (ID: 0x6b47f94d) = (offset_date={}, offset_id={}, offset_peer={}, limit={}))'.format(str(self.offset_date), str(self.offset_id), str(self.offset_peer), str(self.limit))
