from telethon.tl.mtproto_request import MTProtoRequest


class UpdateProfilePhotoRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    photos.updateProfilePhoto#eef579a0 id:InputPhoto crop:InputPhotoCrop = UserProfilePhoto"""

    def __init__(self, id, crop):
        """
        :param id: Telegram type: «InputPhoto».
        :param crop: Telegram type: «InputPhotoCrop».
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default
        self.constructor_id = 0xeef579a0

        self.id = id
        self.crop = crop

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        self.id.on_send(writer)
        self.crop.on_send(writer)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'photos.updateProfilePhoto#eef579a0 id:InputPhoto crop:InputPhotoCrop = UserProfilePhoto'

    def __str__(self):
        return '(photos.updateProfilePhoto (ID: 0xeef579a0) = (id={}, crop={}))'.format(str(self.id), str(self.crop))
