from telethon.tl.mtproto_request import MTProtoRequest


class InputAppEvent(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputAppEvent#770656a8 time:double type:string peer:long data:string = InputAppEvent"""

    def __init__(self, time, type, peer, data):
        """
        :param time: Telegram type: «double».
        :param type: Telegram type: «string».
        :param peer: Telegram type: «long».
        :param data: Telegram type: «string».
        """
        super().__init__()
        self.constructor_id = 0x770656a8

        self.time = time
        self.type = type
        self.peer = peer
        self.data = data

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.write_double(self.time)
        writer.tgwrite_string(self.type)
        writer.write_long(self.peer)
        writer.tgwrite_string(self.data)

    def on_response(self, reader):
        self.time = reader.read_double()
        self.type = reader.tgread_string()
        self.peer = reader.read_long()
        self.data = reader.tgread_string()

    def __repr__(self):
        return 'inputAppEvent#770656a8 time:double type:string peer:long data:string = InputAppEvent'

    def __str__(self):
        return '(inputAppEvent (ID: 0x770656a8) = (time={}, type={}, peer={}, data={}))'.format(str(self.time), str(self.type), str(self.peer), str(self.data))
