from telethon.tl.mtproto_request import MTProtoRequest


class InputMediaPhoto(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputMediaPhoto#e9bfb4f3 id:InputPhoto caption:string = InputMedia"""

    def __init__(self, id, caption):
        """
        :param id: Telegram type: «InputPhoto».
        :param caption: Telegram type: «string».
        """
        super().__init__()
        self.constructor_id = 0xe9bfb4f3

        self.id = id
        self.caption = caption

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        self.id.on_send(writer)
        writer.tgwrite_string(self.caption)

    def on_response(self, reader):
        self.id = reader.tgread_object()
        self.caption = reader.tgread_string()

    def __repr__(self):
        return 'inputMediaPhoto#e9bfb4f3 id:InputPhoto caption:string = InputMedia'

    def __str__(self):
        return '(inputMediaPhoto (ID: 0xe9bfb4f3) = (id={}, caption={}))'.format(str(self.id), str(self.caption))
