from telethon.tl.mtproto_request import MTProtoRequest


class InputMediaPhotoExternal(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputMediaPhotoExternal#b55f4f18 url:string caption:string = InputMedia"""

    def __init__(self, url, caption):
        """
        :param url: Telegram type: «string».
        :param caption: Telegram type: «string».
        """
        super().__init__()
        self.constructor_id = 0xb55f4f18

        self.url = url
        self.caption = caption

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.tgwrite_string(self.url)
        writer.tgwrite_string(self.caption)

    def on_response(self, reader):
        self.url = reader.tgread_string()
        self.caption = reader.tgread_string()

    def __repr__(self):
        return 'inputMediaPhotoExternal#b55f4f18 url:string caption:string = InputMedia'

    def __str__(self):
        return '(inputMediaPhotoExternal (ID: 0xb55f4f18) = (url={}, caption={}))'.format(str(self.url), str(self.caption))
