from telethon.tl.mtproto_request import MTProtoRequest


class InputMediaUploadedPhoto(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    inputMediaUploadedPhoto#f7aff1c0 file:InputFile caption:string = InputMedia"""

    def __init__(self, file, caption):
        """
        :param file: Telegram type: «InputFile».
        :param caption: Telegram type: «string».
        """
        super().__init__()
        self.constructor_id = 0xf7aff1c0

        self.file = file
        self.caption = caption

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        self.file.on_send(writer)
        writer.tgwrite_string(self.caption)

    def on_response(self, reader):
        self.file = reader.tgread_object()
        self.caption = reader.tgread_string()

    def __repr__(self):
        return 'inputMediaUploadedPhoto#f7aff1c0 file:InputFile caption:string = InputMedia'

    def __str__(self):
        return '(inputMediaUploadedPhoto (ID: 0xf7aff1c0) = (file={}, caption={}))'.format(str(self.file), str(self.caption))
