from telethon.tl.mtproto_request import MTProtoRequest


class State(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. Original .tl definition below.
    updates.state#a56c2a3e pts:int qts:int date:date seq:int unread_count:int = updates.State"""

    def __init__(self, pts, qts, date, seq, unread_count):
        """
        :param pts: Telegram type: «int».
        :param qts: Telegram type: «int».
        :param date: Telegram type: «date».
        :param seq: Telegram type: «int».
        :param unread_count: Telegram type: «int».
        """
        super().__init__()
        self.constructor_id = 0xa56c2a3e

        self.pts = pts
        self.qts = qts
        self.date = date
        self.seq = seq
        self.unread_count = unread_count

    def on_send(self, writer):
        writer.write_int(self.constructor_id, signed=False)
        writer.write_int(self.pts)
        writer.write_int(self.qts)
        writer.tgwrite_date(self.date)
        writer.write_int(self.seq)
        writer.write_int(self.unread_count)

    def on_response(self, reader):
        self.pts = reader.read_int()
        self.qts = reader.read_int()
        self.date = reader.tgread_date()
        self.seq = reader.read_int()
        self.unread_count = reader.read_int()

    def __repr__(self):
        return 'updates.state#a56c2a3e pts:int qts:int date:date seq:int unread_count:int = updates.State'

    def __str__(self):
        return '(updates.state (ID: 0xa56c2a3e) = (pts={}, qts={}, date={}, seq={}, unread_count={}))'.format(str(self.pts), str(self.qts), str(self.date), str(self.seq), str(self.unread_count))
